﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.3
@EndOfDesignText@
Sub Class_Globals
'	Private spice As JavaObject
	Dim nativeMe As JavaObject
End Sub

'initialize the JSPICE object
Public Sub Initialize
'	spice.InitializeStatic("org.knowm.jspice.JSpice")
	nativeMe = Me

End Sub

'simulate the circuit
'a valid netlist needs to be passed for simulation purposes
Public Sub Simulate (Netlist As JavaObject)

	Try
		nativeMe.RunMethod("simulate", Array(Netlist))
	Catch
		Log("LAST EXCEPTION: " & LastException)
	End Try		
	
End Sub

'call back from the inline Java code with the result of simulation as a String
'it will call sub jspice_result in Main and pass the String result to it so that the values can be used in the B4J UI
Public Sub jspicecallback(mystring As String)
'	Log("IN THE CALLBACK")

'	Log("mystring = " & mystring)
	CallSubDelayed2(Main,"jspice_result", mystring)
	Sleep(1000)

End Sub

#if Java


import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;

import org.knowm.configuration.ConfigurationException;
import org.knowm.configuration.ConfigurationFactory;
import org.knowm.configuration.YamlConfigurationFactory;
import org.knowm.configuration.provider.ConfigurationSourceProvider;
import org.knowm.configuration.provider.FileConfigurationSourceProvider;
import org.knowm.configuration.provider.ResourceConfigurationSourceProvider;
import org.knowm.jackson.Jackson;
import org.knowm.jspice.netlist.Netlist;
import org.knowm.jspice.netlist.spice.SPICENetlistBuilder;
import org.knowm.jspice.simulate.SimulationConfig;
import org.knowm.jspice.simulate.SimulationPlotter;
import org.knowm.jspice.simulate.SimulationResult;
import org.knowm.jspice.simulate.dcoperatingpoint.DCOPConfig;
import org.knowm.jspice.simulate.dcoperatingpoint.DCOperatingPoint;
import org.knowm.jspice.simulate.dcoperatingpoint.DCOperatingPointResult;
import org.knowm.jspice.simulate.dcsweep.DCSweep;
import org.knowm.jspice.simulate.dcsweep.DCSweepConfig;
import org.knowm.jspice.simulate.transientanalysis.TransientAnalysis;
import org.knowm.jspice.simulate.transientanalysis.TransientConfig;
import org.knowm.validation.BaseValidator;

  private static boolean isFromCommandline = false;
  private static String outFormat = "";
  private static String fileName = "";

	public String myresult;
	
	public String getMyResult() {
		return myresult;
	} 

  public void simulate(Netlist netlist) {
  	//BA.Log("IN SIMULATE");
	myresult = "";

    SimulationConfig simulationConfig = netlist.getSimulationConfig();

    if (simulationConfig == null || simulationConfig instanceof DCOPConfig) {

	//BA.Log("HERE 1");
      DCOperatingPointResult dcOpResult = new DCOperatingPoint(netlist).run();
      if (isFromCommandline) {

      } else {
        //System.out.println(dcOpResult.toString());
		
		//BA.Log("HERE 2");
		myresult = dcOpResult.toString();
		ba.raiseEventFromUI(this, "jspicecallback", new Object[] {myresult});
      }
      //return null;

    } else if (simulationConfig instanceof DCSweepConfig) {

      DCSweepConfig dcSweepConfig = (DCSweepConfig) simulationConfig;

      // run DC sweep
      DCSweep dcSweep = new DCSweep(netlist);
      dcSweep.addSweepConfig(dcSweepConfig);
      SimulationResult simulationResult = dcSweep.run(dcSweepConfig.getObserveID());
      if (isFromCommandline) {

      } else {
	  	myresult = simulationResult.toString();
		ba.raiseEventFromUI(this, "jspicecallback", new Object[] {myresult});
        //System.out.println(simulationResult.toString());
        //SimulationPlotter.plot(simulationResult, new String[]{dcSweepConfig.getObserveID()});
      }
      //return simulationResult;

    } else if (simulationConfig instanceof TransientConfig) {

	  //BA.Log("IN TRANSIENT CONFIG");
      TransientConfig simulationConfigTransient = (TransientConfig) simulationConfig;

      // run TransientAnalysis
      TransientAnalysis transientAnalysis = new TransientAnalysis(netlist, simulationConfigTransient);
      SimulationResult simulationResult = transientAnalysis.run();

        //System.out.println(simulationResult.toString());
		
		//BA.Log(" ");
		//BA.Log(" ");
        //System.out.println(simulationResult.toXyceString());
		myresult = simulationResult.toString();
		ba.raiseEventFromUI(this, "jspicecallback", new Object[] {myresult});
    }
  }



#End If

